.docker_login: &docker-login
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN ${CI_REGISTRY}

.docker_build_dind: &docker-build-dind
    - docker build -t ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG} .

.docker_push: &docker-push
    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}

.var_docker:
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_TLS_CERTDIR: ""

.docker_backend_build:
  stage: build
  image: docker:stable
  services:
    - docker:dind
  script:
    - *docker-login
    - *docker-build-dind
    - *docker-push
  rules:
    - if: $CI_COMMIT_BRANCH == "dev"
  tags:
    - intens01

.docker_backend_release:
  stage: release
  image: docker:stable
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN ${CI_REGISTRY}
    - docker pull ${CI_REGISTRY_IMAGE}:dev
    - docker tag ${CI_REGISTRY_IMAGE}:dev ${CI_REGISTRY_IMAGE}:latest
    - docker push ${CI_REGISTRY_IMAGE}:latest
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - when: never
  tags:
    - intens01

.docker_backend_deploy:
  stage: deploy
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN ${CI_REGISTRY}
    - docker rmi $(docker images -aq) || true
    - docker pull ${CI_REGISTRY}/${INTENS_PROJECT_PATH}${INTENS_PROJECT_BACKEND}:dev
    - docker pull ${CI_REGISTRY}/${INTENS_PROJECT_PATH}${INTENS_PROJECT_FRONTEND}:latest
    - docker rm -f $(docker ps -aq) || true
    - docker compose up -d
  rules:
    - if: $CI_COMMIT_BRANCH == "dev"
  tags:
    - dev-shell

